package com.engine.jclproduct.service.impl;

import com.cloudstore.eccom.result.WeaResultMsg;
import com.engine.core.impl.Service;
import com.engine.jclproduct.component.WeaverWeaTable;
import com.engine.jclproduct.entity.vo.LeaveResourceVo;
import com.engine.jclproduct.entity.vo.TimeResourceVo;
import com.engine.jclproduct.entity.vo.TransferResourceVo;
import com.engine.jclproduct.service.EmployeeRecordReportService;
import com.engine.jclproduct.utils.EmploymentUtil;
import org.apache.commons.lang3.StringUtils;
import weaver.common.DateUtil;
import weaver.general.Util;

import java.util.HashMap;
import java.util.Map;

/**
 * @Author liang.cheng
 * @Date 2024/10/25 11:11 AM
 * @Description: TODO
 * @Version 1.0
 */
public class EmployeeRecordReportServiceImpl extends Service implements EmployeeRecordReportService {

    @Override
    public Map<String, Object> commonReport(Map<String, Object> params) {
        Map<String, Object> result = new HashMap<>();
        String selectedKey = Util.null2String(params.get("selectedKey"));
        switch (selectedKey) {
            case "0":
                result = timeResourece(params);
                break;
            case "1":
                result = leaveResourece(params);
                break;
            case "2":
                result = transferResourece(params);
                break;
            default:
                break;
        }


        return result;
    }

    @Override
    public Map<String, Object> timeResourece(Map<String, Object> params) {
        Map<String, Object> resultMap = new HashMap<>(8);
        
        WeaverWeaTable<TimeResourceVo> table = new WeaverWeaTable<>(user, TimeResourceVo.class);
        String sqlWhere = buildtimeResoureceSql(params);
        table.setSqlwhere(sqlWhere);
        WeaResultMsg result = new WeaResultMsg(false);
        result.putAll(table.makeDataResult());
        result.success();
        resultMap.putAll(result.getResultMap());
        return resultMap;
    }

    @Override
    public Map<String, Object> leaveResourece(Map<String, Object> params) {
        Map<String, Object> resultMap = new HashMap<>(8);

        WeaverWeaTable<TimeResourceVo> table = new WeaverWeaTable<>(user, LeaveResourceVo.class);
        String sqlWhere = buildLeaveResoureceSql(params);
        sqlWhere += " and employeeStatus in (5)";
        table.setSqlwhere(sqlWhere);
        WeaResultMsg result = new WeaResultMsg(false);
        result.putAll(table.makeDataResult());
        result.success();
        resultMap.putAll(result.getResultMap());
        return resultMap;
    }

    @Override
    public Map<String, Object> transferResourece(Map<String, Object> params) {
        Map<String, Object> resultMap = new HashMap<>(8);

        WeaverWeaTable<TimeResourceVo> table = new WeaverWeaTable<>(user, TransferResourceVo.class);
        String sqlWhere = buildtransferResoureceSql(params);
        sqlWhere += " and changType in (2)";
        table.setSqlwhere(sqlWhere);
        WeaResultMsg result = new WeaResultMsg(false);
        result.putAll(table.makeDataResult());
        result.success();
        resultMap.putAll(result.getResultMap());
        return resultMap;
    }

    private String buildtransferResoureceSql(Map<String, Object> params) {
        String pointValue = Util.null2String(params.get("pointValue"));
        String startDate = Util.null2String(params.get("startDate"));
        String endDate = Util.null2String(params.get("endDate"));
        String sql = getLeaveSql(pointValue,startDate,endDate);
        String sqlWhere = " where 1=1 "+sql;
        String resourceId = Util.null2String(params.get("resourceId"));
        if (StringUtils.isNotBlank(resourceId)) {
            sqlWhere += " and userId ="+resourceId;
        }

        String departmentId = Util.null2String(params.get("departmentId"));
        if (StringUtils.isNotBlank(departmentId)) {
            sqlWhere += " and departmentId ="+departmentId;
        }

        String statusValue = Util.null2String(params.get("statusValue"));
        if (StringUtils.isNotBlank(statusValue)) {
            sqlWhere += " and employeeStatus in ("+statusValue+")";
        }

        return sqlWhere;
    }


    private String buildLeaveResoureceSql(Map<String, Object> params) {
        String pointValue = Util.null2String(params.get("pointValue"));
        String startDate = Util.null2String(params.get("startDate"));
        String endDate = Util.null2String(params.get("endDate"));
        String sql = getLeaveSql(pointValue,startDate,endDate);
        String sqlWhere = " where 1=1 "+sql;
        String departmentId = Util.null2String(params.get("departmentId"));
        if (StringUtils.isNotBlank(departmentId)) {
            sqlWhere += " and departmentId ="+departmentId;
        }

        return sqlWhere;
    }

    private String getLeaveSql(String pointValue, String startDate, String endDate) {
        String sql = "";
        switch (pointValue){
            case "0":
                break;
            case "1":
                String today = DateUtil.getCurrentDate();
                sql += " and startDate = '"+today+"' and stopDate >= '"+today+"'";
                break;
            case "2":
                String firstDayOfWeek = DateUtil.getFirstDayOfWeek();
                String lastDayOfWeek = DateUtil.getLastDayOfWeek();
                sql += " and startDate >= '"+firstDayOfWeek+"' and startDate <= '"+lastDayOfWeek+"' and stopDate >= '"+lastDayOfWeek+"'";
                break;
            case "3":
                String firstDayOfMonth = DateUtil.getFirstDayOfMonthToString();
                String lastDayOfMonth = DateUtil.getLastDayOfMonthToString();
                sql += " and startDate >= '"+firstDayOfMonth+"' and startDate <= '"+lastDayOfMonth+"' and stopDate >= '"+lastDayOfMonth+"'";
                break;
            case "5":
                String firstDayOfYear = DateUtil.getFirstDayOfYear();
                String lastDayOfYear = DateUtil.getLastDayOfYear();
                sql += " and startDate >= '"+firstDayOfYear+"' and startDate <= '"+lastDayOfYear+"'  and stopDate >= '"+lastDayOfYear+"'";
                break;
            case "7":
                String firstDayOfPreviousMonth = EmploymentUtil.firstDayOfPreviousMonth();
                String lastDayOfPreviousMonth = EmploymentUtil.lastDayOfPreviousMonth();
                sql += " and startDate >= '"+firstDayOfPreviousMonth+"' and startDate <= '"+lastDayOfPreviousMonth+"'  and stopDate >= '"+lastDayOfPreviousMonth+"'";
                break;
            case "8":
                String firstDayOfPreviousYear = EmploymentUtil.firstDayOfPreviousYear();
                String lastDayOfPreviousYear = EmploymentUtil.lastDayOfPreviousYear();
                sql += " and startDate >= '"+firstDayOfPreviousYear+"' and startDate <= '"+lastDayOfPreviousYear+"' and stopDate >= '"+lastDayOfPreviousYear+"'";
                break;
            case "6":
                sql += " and startDate >= '"+startDate+"' and startDate <= '"+endDate+"' and stopDate >= '"+endDate+"'";
                break;
            default:
                break;
        }

        return sql;
    }

    private String buildtimeResoureceSql(Map<String, Object> params) {
        String pointValue = Util.null2String(params.get("pointValue"));
        String startDate = Util.null2String(params.get("startDate"));

        String sql = getPointSql(pointValue,startDate);
        String sqlWhere = " where 1=1 and "+sql;

        String statusValue = Util.null2String(params.get("statusValue"));
        if (StringUtils.isNotBlank(statusValue)) {
            sqlWhere += " and employeeStatus in ("+statusValue+")";
        }

        String resourceId = Util.null2String(params.get("resourceId"));
        if (StringUtils.isNotBlank(resourceId)) {
            sqlWhere += " and userId ="+resourceId;
        }

        String departmentId = Util.null2String(params.get("departmentId"));
        if (StringUtils.isNotBlank(departmentId)) {
            sqlWhere += " and departmentId ="+departmentId;
        }

        return sqlWhere;
    }

    private String getPointSql(String pointValue, String startDate) {
        String sql = "";
        switch (pointValue){
            case "0":
                String currentDate = DateUtil.getCurrentDate();
                sql += " startDate <= '"+currentDate+"' and stopDate >= '"+currentDate+"'";
                break;
            case "1":
                String yesterday = DateUtil.getYesterday();
                sql += " startDate <= '"+yesterday+"' and stopDate >= '"+yesterday+"'";
                break;
            case "2":
                String firstDayOfWeek = DateUtil.getFirstDayOfWeek();
                sql += " startDate <= '"+firstDayOfWeek+"' and stopDate >= '"+firstDayOfWeek+"'";
                break;
            case "3":
                String lastDayOfWeek = DateUtil.getLastDayOfWeek();
                sql += " startDate <= '"+lastDayOfWeek+"' and stopDate >= '"+lastDayOfWeek+"'";
                break;
            case "4":
                String firstDayOfMonth = DateUtil.getFirstDayOfMonthToString();
                sql += " startDate <= '"+firstDayOfMonth+"' and stopDate >= '"+firstDayOfMonth+"'";
                break;
            case "5":
                String lastDayOfMonth = DateUtil.getLastDayOfMonthToString();
                sql += " startDate <= '"+lastDayOfMonth+"' and stopDate >= '"+lastDayOfMonth+"'";
                break;
            case "7":
                String firstDayOfYear = DateUtil.getFirstDayOfYear();
                sql += " startDate <= '"+firstDayOfYear+"' and stopDate >= '"+firstDayOfYear+"'";
                break;
            case "8":
                String lastDayOfYear = DateUtil.getLastDayOfYear();
                sql += " startDate <= '"+lastDayOfYear+"' and stopDate >= '"+lastDayOfYear+"'";
                break;
            case "9":
                String firstDayOfPreviousMonth = EmploymentUtil.firstDayOfPreviousMonth();
                sql += " startDate <= '"+firstDayOfPreviousMonth+"' and stopDate >= '"+firstDayOfPreviousMonth+"'";
                break;
            case "10":
                String lastDayOfPreviousMonth = EmploymentUtil.lastDayOfPreviousMonth();
                sql += " startDate <= '"+lastDayOfPreviousMonth+"' and stopDate >= '"+lastDayOfPreviousMonth+"'";
                break;
            case "11":
                String firstDayOfPreviousYear = EmploymentUtil.firstDayOfPreviousYear();
                sql += " startDate <= '"+firstDayOfPreviousYear+"' and stopDate >= '"+firstDayOfPreviousYear+"'";
                break;
            case "12":
                String lastDayOfPreviousYear = EmploymentUtil.lastDayOfPreviousYear();
                sql += " startDate <= '"+lastDayOfPreviousYear+"' and stopDate >= '"+lastDayOfPreviousYear+"'";
                break;
            case "6":
                sql += " startDate <= '"+startDate+"' and stopDate >= '"+startDate+"'";
                break;
            default:
                break;
        }
        return sql;

    }


}
