package test;

import com.engine.jclproduct.utils.EmploymentUtil;
import com.weaver.general.TimeUtil;
import weaver.common.DateUtil;

import java.time.LocalDate;
import java.time.Year;
import java.time.YearMonth;
import java.time.format.DateTimeFormatter;
import java.util.Map;

/**
 * @Author weaver_cl
 * @Description:
 * @Date 2022/10/9
 * @Version V1.0
 **/
public class MainTest {

    public static void main(String[] args) {
        // 获取当前日期
        LocalDate now = LocalDate.now();

        // 获取上一年的 Year 对象
        Year previousYear = Year.from(now).minusYears(1);

        // 获取上一年的第一天
        LocalDate firstDayOfPreviousYear = previousYear.atDay(1);

        // 获取上一年的最后一天
        LocalDate lastDayOfPreviousYear = previousYear.atMonth(12).atEndOfMonth();

        // 创建日期格式化器
        DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM-dd");

        // 格式化日期为字符串
        String firstDayOfPreviousYearStr = firstDayOfPreviousYear.format(formatter);
        String lastDayOfPreviousYearStr = lastDayOfPreviousYear.format(formatter);

        // 打印结果
        System.out.println("上一年的第一天: " + firstDayOfPreviousYearStr);
        System.out.println("上一年的最后一天: " + lastDayOfPreviousYearStr);
    }
}
